#!/usr/bin/python
# -*- coding:utf8 -*-
# Codé par 20-100 (commencé le 21/06/12)

# Un bot IRC pour kicker à tour de bras de #déprime

import threading
import random
import time
import socket, ssl, json
import pickle
import re
import os
import signal
import sys

# Oui, j'ai recodé ma version d'irclib pour pouvoir rattrapper les SIGHUP
sys.path.insert(0, "/home/vincent/scripts/python-myirclib")
import irclib
import ircbot

import sys

# Fichier de conf
import config

def get_config_logfile(serveur):
    serveurs={"acoeur.crans.org":"acoeur","irc.crans.org":"crans"}
    return config.logfile_template%(serveurs[serveur])


def log(serveur,channel,auteur=None,message=None):
    f=open(get_config_logfile(serveur),"a")
    if auteur==message==None:
        # alors c'est que c'est pas un channel mais juste une ligne de log
        chain="%s %s"%(time.strftime("%F %T"),channel)
    else:
        chain="%s [%s:%s] %s"%(time.strftime("%F %T"),channel,auteur,message)
    f.write(chain+"\n")
    if config.debug_stdout:
        print chain
    f.close()

def ignore_event(serv, ev):
    """Retourne ``True`` si il faut ignorer cet évènement."""
    for (blackmask, exceptmask) in config.blacklisted_masks:
        usermask = ev.source()
        if exceptmask is None:
            exceptit = False
        else:
            exceptit = bool(irclib.mask_matches(usermask, exceptmask))
        blackit = bool(irclib.mask_matches(usermask, blackmask))
        if blackit and not exceptit:
            return True

reg_is_smiley = re.compile(u".*("+u"|".join(config.smileys)+u")")
def is_smiley(chain):
    chain=unicode(chain,"utf8")
    o=re.match(reg_is_smiley,chain)
    return o

reg_is_anglicisme = re.compile(u".*(?:^| )(" + u"|".join(config.anglicismes) + u")(?:$|\.| |,|;)")
def is_anglicisme(chain):
    chain = unicode(chain, "utf8").lower()
    o = re.match(reg_is_anglicisme, chain)
    return o

# Cette liste contient la liste des raisons pour lesquelles on peut se faire kicker
# chaque élément contient :
#  - la fonction de détection du kick (qui matchera une regexp et renverra l'objet de match)
#  - la raison donnée au moment du kick ({0} étant remplacé par ce qui a matché)
config.kicking_list = [
[is_smiley, u'"{0}" ? Ici on déprime.'],
[is_anglicisme, u'"{0}" ? Get out, you and your fucking anglicism !']
]

def is_something(chain,matches,avant=u".*(?:^| )",apres=u"(?:$|\.| |,|;).*",case_sensitive=False,debug=False):
    if case_sensitive:
        chain=unicode(chain,"utf8")
    else:
        chain=unicode(chain,"utf8").lower()
    allmatches="("+"|".join(matches)+")"
    reg=(avant+allmatches+apres).lower()
    o=re.match(reg,chain)
    return o

def is_insult(chain,debug=True):
    return is_something(chain,config.insultes,avant=".*(?:^| |')")
def is_not_insult(chain):
    chain=unicode(chain,"utf8")
    insult_regexp=u"("+u"|".join(config.insultes)+u")"
    middle_regexp=u"(une? (?:(?:putain|enfoiré) d(?:e |'))*|)(?:| super )(?: (?:gros|petit|grand|énorme) |)"
    reg=".*pas %s%s.*"%(middle_regexp,insult_regexp)
    if re.match(reg,chain):
        return True
    else:
        return False
def is_compliment(chain,debug=True):
    return is_something(chain,config.compliment_triggers,avant=".*(?:^| |')")
def is_perdu(chain):
    return is_something(chain,config.perdu)
def is_tag(chain):
    return is_something(chain,config.tag_triggers)
def is_tesla(chain):
    return is_something(chain,config.tesla_triggers,avant=u"^",apres=u"$",debug=True)
def is_merci(chain):
    return is_something(chain,config.merci_triggers)
def is_tamere(chain):
    return is_something(chain,config.tamere_triggers)
def is_bad_action_trigger(chain,pseudo):
    return is_something(chain,config.bad_action_triggers,avant=u"^",
                            apres="(?: [a-z]*ment)? %s($|\.| |,|;).*"%(pseudo))
def is_good_action_trigger(chain,pseudo):
    return is_something(chain,config.good_action_triggers,avant=u"^",
                            apres="(?: [a-z]*ment)? %s($|\.| |,|;).*"%(pseudo))
def is_bonjour(chain):
    return is_something(chain,config.bonjour_triggers,avant=u"^")
def is_bonne_nuit(chain):
    return is_something(chain,config.bonne_nuit_triggers,avant=u"^")
def is_pan(chain):
    return re.match(u"^(pan|bim|bang)( .*)?$",unicode(chain,"utf8").lower().strip())

def is_time(conf):
    _,_,_,h,m,s,_,_,_=time.localtime()
    return (conf[0],0,0)<(h,m,s)<(conf[1],0,0)
def is_day():
    return is_time(config.daytime)
def is_night():
    return is_time(config.nighttime)

      
class UnicodeBotError(Exception):
    pass
def bot_unicode(chain):
    try:
        unicode(chain,"utf8")
    except UnicodeDecodeError as exc:
        raise UnicodeBotError

class Themis(ircbot.SingleServerIRCBot):
    def __init__(self,serveur,debug=False):
        temporary_pseudo=config.irc_pseudo+str(random.randrange(10000,100000))
        ircbot.SingleServerIRCBot.__init__(self, [(serveur, 6667)],
                              temporary_pseudo,"Des[bot]e de #déprime", 10)
        self.debug=debug
        self.serveur=serveur
        self.overops=config.overops
        self.ops=self.overops+config.ops
        self.report_bugs_to=config.report_bugs_to
        self.chanlist=config.chanlist
        self.kick_channels=config.kick_channels
        self.stay_channels=config.stay_channels
        self.quiet_channels=config.quiet_channels
        self.last_perdu=0


    def give_me_my_pseudo(self,serv):
        serv.privmsg("NickServ","RECOVER %s %s"%(config.irc_pseudo,config.irc_password))
        serv.privmsg("NickServ","RELEASE %s %s"%(config.irc_pseudo,config.irc_password))
        time.sleep(0.3)
        serv.nick(config.irc_pseudo)

    def give_me_my_op_status(self,serv,chan):
        serv.privmsg("ChanServ","OP %s"%(chan))

    def on_welcome(self, serv, ev):
        self.serv=serv # ça serv ira
        self.give_me_my_pseudo(serv)
        serv.privmsg("NickServ","identify %s"%(config.irc_password))
        log(self.serveur,"Connected")
        if self.debug:
            self.chanlist=["#bot"]
            self.kick_channels=["#bot"]
        for c in self.chanlist:
            log(self.serveur,"JOIN %s"%(c))
            serv.join(c)
            self.give_me_my_op_status(serv,c)


    def lost(self,serv,channel,forced=False):
        if self.last_perdu+config.time_between_perdu<time.time() or forced:
            if not channel in self.quiet_channels or forced:
                serv.privmsg(channel,"J'ai perdu !")
            self.last_perdu=time.time()
            delay=config.time_between_perdu_trigger
            delta=config.time_between_perdu_trigger_delta
            serv.execute_delayed(random.randrange(delay-delta,delay+delta),self.lost,(serv,channel))
    
    def pourmoi(self, serv, message):
        """renvoie (False,lemessage) ou (True, le message amputé de "pseudo: ")"""
        pseudo=self.nick
        size=len(pseudo)
        if message[:size]==pseudo and len(message)>size and message[size]==":":
            return (True,message[size+1:].lstrip(" "))
        else:
            return (False,message)

    def on_privmsg(self, serv, ev):
        if ignore_event(serv, ev):
            return
        message=ev.arguments()[0]
        auteur = irclib.nm_to_n(ev.source())
        try:
            test=bot_unicode(message)
        except UnicodeBotError:
            if config.utf8_trigger:
                serv.privmsg(auteur, random.choice(config.utf8_fail_answers).encode("utf8"))
            return
        message=message.split()
        cmd=message[0].lower()
        notunderstood=False
        if cmd=="help":
            helpdico={"help":["""HELP <commande>
 Affiche de l'aide sur la commande""",None,None],
 "join": [None, """JOIN <channel>
 Me fait rejoindre le channel""",None],
 "leave": [None,"""LEAVE <channel>
 Me fait quitter le channel (sauf s'il est dans ma stay_list).""",None],
 "quiet": [None,"""QUIET <channel>
 Me rend silencieux sur le channel.""",None],
 "noquiet": [None,"""NOQUIET <channel>
 Me rend la parole sur le channel.""",None],
 "reload": [None,"""RELOAD
 Recharge la configuration.""",None],
 "say": [None,None,"""SAY <channel> <message>
 Me fait parler sur le channel."""],
 "do": [None,None,"""DO <channel> <action>
 Me fait faitre une action (/me) sur le channel."""],
 "stay": [None,None,"""STAY <channel>
 Ajoute le channel à ma stay_list."""],
 "nostay": [None,None,"""NOSTAY <channel>
 Retire le channel de ma stay_list."""],
 "ops": [None,None,"""OPS
 Affiche la liste des ops."""],
 "overops": [None,None,"""OVEROPS
 Affiche la liste des overops."""],
 "kick": [None,None,"""KICK <channel> <pseudo> [<raison>]
 Kicke <pseudo> du channel (Il faut bien entendu que j'y sois op)."""],
 "die": [None,None,"""DIE
 Me déconnecte du serveur IRC."""]
 }
            helpmsg_default="Liste des commandes disponibles :\nHELP"
            helpmsg_ops=" JOIN LEAVE QUIET NOQUIET LOST RELOAD"
            helpmsg_overops=" SAY DO STAY NOSTAY OPS OVEROPS KICK DIE"
            op,overop=auteur in self.ops, auteur in self.overops
            if len(message)==1:
                helpmsg=helpmsg_default
                if op:
                    helpmsg+=helpmsg_ops
                if overop:
                    helpmsg+=helpmsg_overops
            else:
                helpmsgs=helpdico.get(message[1].lower(),["Commande inconnue.",None,None])
                helpmsg=helpmsgs[0]
                if op and helpmsgs[1]:
                    if helpmsg:
                        helpmsg+="\n"+helpmsgs[1]
                    else:
                        helpmsg=helpmsgs[1]
                if overop and helpmsgs[2]:
                    if helpmsg:
                        helpmsg+="\n"+helpmsgs[2]
                    else:
                        helpmsg=helpmsgs[2]
            for ligne in helpmsg.split("\n"):
                serv.privmsg(auteur,ligne)
        elif cmd=="join":
            if auteur in self.ops:
                if len(message)>1:
                    if message[1] in self.chanlist:
                        serv.privmsg(auteur,"Je suis déjà sur %s"%(message[1]))
                    else:
                        serv.join(message[1])
                        self.chanlist.append(message[1])
                        serv.privmsg(auteur,"Channels : "+" ".join(self.chanlist))
                        log(self.serveur,"priv",auteur," ".join(message))
                else:
                    serv.privmsg(auteur,"Channels : "+" ".join(self.chanlist))
            else:
                notunderstood=True
        elif cmd=="leave":
            if auteur in self.ops and len(message)>1:
                if message[1] in self.chanlist:
                    if not (message[1] in self.stay_channels) or auteur in self.overops:
                        self.quitter(message[1]," ".join(message[2:]))
                        self.chanlist.remove(message[1])
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                    else:
                        serv.privmsg(auteur,random.choice(config.leave_fail_messages))
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
                else:
                    serv.privmsg(auteur,"Je ne suis pas sur %s"%(message[1]))
            else:
                notunderstood=True
        elif cmd=="stay":
            if auteur in self.overops:
                if len(message)>1:
                    if message[1] in self.stay_channels:
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
                        serv.privmsg(auteur,"Je stay déjà sur %s."%(message[1]))
                    else:
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                        self.stay_channels.append(message[1])
                        serv.privmsg(auteur,"Stay channels : "+" ".join(self.stay_channels))
                else:
                    serv.privmsg(auteur,"Stay channels : "+" ".join(self.stay_channels))
            else:
                notunderstood=True
        elif cmd=="nostay":
            if auteur in self.overops:
                if len(message)>1:
                    if message[1] in self.stay_channels:
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                        self.stay_channels.remove(message[1])
                        serv.privmsg(auteur,"Stay channels : "+" ".join(self.stay_channels))
                    else:
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
                        serv.privmsg(auteur,"Je ne stay pas sur %s."%(message[1]))

            else:
                notunderstood=True
        elif cmd=="die":
            if auteur in self.overops:
                log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                self.mourir()
            else:
                notunderstood=True
        elif cmd=="quiet":
            if auteur in self.ops:
                if len(message)>1:
                    if message[1] in self.quiet_channels:
                        serv.privmsg(auteur,"Je me la ferme déjà sur %s"%(message[1]))
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
                    else:
                        self.quiet_channels.append(message[1])
                        serv.privmsg(auteur,"Quiet channels : "+" ".join(self.quiet_channels))
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                else:
                    serv.privmsg(auteur,"Quiet channels : "+" ".join(self.quiet_channels))
            else:
                notunderstood=True
        elif cmd=="noquiet":
            if auteur in self.ops:
                if len(message)>1:
                    if message[1] in self.quiet_channels:
                        self.quiet_channels.remove(message[1])
                        serv.privmsg(auteur,"Quiet channels : "+" ".join(self.quiet_channels))
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                    else:
                        serv.privmsg(auteur,"Je ne me la ferme pas sur %s."%(message[1]))
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
            else:
                notunderstood=True
        elif cmd=="reload":
            if auteur in self.ops:
                self.reload(auteur)
                log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
            else:
                notunderstood=True
        elif cmd=="say":
            if auteur in self.overops and len(message)>2:
                serv.privmsg(message[1]," ".join(message[2:]))
                log(self.serveur,"priv",auteur," ".join(message))
            elif len(message)<=2:
                serv.privmsg(auteur,"Syntaxe : SAY <channel> <message>")
            else:
                notunderstood=True
        elif cmd=="do":
            if auteur in self.overops and len(message)>2:
                serv.action(message[1]," ".join(message[2:]))
                log(self.serveur,"priv",auteur," ".join(message))
            elif len(message)<=2:
                serv.privmsg(auteur,"Syntaxe : DO <channel> <action>")
            else:
                notunderstood=True
        elif cmd=="kick":
            if auteur in self.overops and len(message)>2:
                serv.kick(message[1],message[2]," ".join(message[3:]))
                log(self.serveur,"priv",auteur," ".join(message))
            elif len(message)<=2:
                serv.privmsg(auteur,"Syntaxe : KICK <channel> <pseudo> [<raison>]")
            else:
                notunderstood=True
        elif cmd=="ops":
            if auteur in self.overops:
                serv.privmsg(auteur," ".join(self.ops))
            else:
                notunderstood=True
        elif cmd=="overops":
            if auteur in self.overops:
                serv.privmsg(auteur," ".join(self.overops))
            else:
                notunderstood=True
        else:
            notunderstood=True
        if notunderstood:
            serv.privmsg(auteur,"Je n'ai pas compris. Essayez HELP…")
    
    def on_pubmsg(self, serv, ev):
        if ignore_event(serv, ev):
            return
        auteur = irclib.nm_to_n(ev.source())
        canal = ev.target()
        message = ev.arguments()[0]
        try:
            test=bot_unicode(message)
        except UnicodeBotError:
            if config.utf8_trigger and not canal in self.quiet_channels:
                serv.privmsg(canal, (u"%s: %s"%(auteur,random.choice(config.utf8_fail_answers))).encode("utf8"))
            return
        pour_moi,message=self.pourmoi(serv,message)
        for (detect, reason) in config.kicking_list:
            matching = detect(message)
            if matching:
                if canal in self.kick_channels:
                    serv.kick(canal,auteur,(reason.format(matching.groups()[0])).encode("utf8"))
                    return
        if pour_moi and message.split()!=[]:
            cmd=message.split()[0].lower()
            try:
                args=" ".join(message.split()[1:])
            except:
                args=""
            if cmd in ["meurs","die","crève","pends-toi"]:
                if auteur in self.overops:
                    log(self.serveur,canal,auteur,message+"[successful]")
                    self.mourir()
                else:
                    serv.privmsg(canal,"%s: %s"%(auteur,random.choice(config.quit_fail_messages)))
                    log(self.serveur,canal,auteur,message+"[failed]")
            elif cmd == "reload":
                if auteur in self.ops:
                    log(self.serveur, canal, auteur, message+"[successful]")
                    self.reload(canal)
            elif cmd in ["part","leave","dégage","va-t-en"]:
                if auteur in self.ops and (not (canal in self.stay_channels)
                                           or auteur in self.overops):
                    self.quitter(canal)
                    log(self.serveur,canal,auteur,message+"[successful]")
                    if canal in self.chanlist:
                        self.chanlist.remove(canal)
                else:
                    serv.privmsg(canal,"%s: %s"%(auteur,random.choice(config.leave_fail_messages)))
                    log(self.serveur,canal,auteur,message+"[failed]")
            
            elif cmd in ["deviens","pseudo"]:
                if auteur in self.ops:
                    become=args
                    serv.nick(become)
                    log(self.serveur,canal,auteur,message+"[successful]")
    
            elif cmd in ["meur", "meurt","meurre","meurres"] and not canal in self.quiet_channels:
                serv.privmsg(canal,'%s: Mourir, impératif, 2ème personne du singulier : "meurs" (de rien)'%(auteur))
            elif cmd in ["ping"] and not canal in self.quiet_channels:
                serv.privmsg(canal,"%s: pong"%(auteur))
#            if is_insult(message) and not canal in self.quiet_channels:
#                if is_not_insult(message):
#                    answer=random.choice(config.compliment_answers)
#                    for ligne in answer.split("\n"):
#                        serv.privmsg(canal,"%s: %s"%(auteur,ligne.encode("utf8")))
#                else:
#                    answer=random.choice(config.insultes_answers)
#                    for ligne in answer.split("\n"):
#                        serv.privmsg(canal,"%s: %s"%(auteur,ligne.encode("utf8")))
#            elif is_compliment(message) and not canal in self.quiet_channels:
#                answer=random.choice(config.compliment_answers)
#                for ligne in answer.split("\n"):
#                    serv.privmsg(canal,"%s: %s"%(auteur,ligne.encode("utf8")))
            elif is_tesla(message) and not canal in self.quiet_channels:
                l1,l2=config.tesla_answers,config.tesla_actions
                n1,n2=len(l1),len(l2)
                i=random.randrange(n1+n2)
                if i>=n1:
                    serv.action(canal,l2[i-n1].encode("utf8"))
                else:
                    serv.privmsg(canal,"%s: %s"%(auteur,l1[i].encode("utf8")))
            elif is_tag(message) and not canal in self.quiet_channels:
                if auteur in self.ops:
                    action=random.choice(config.tag_actions)
                    serv.action(canal,action.encode("utf8"))
                    self.quiet_channels.append(canal)
                else:
                    answer=random.choice(config.tag_answers)
                    for ligne in answer.split("\n"):
                        serv.privmsg(canal,"%s: %s"%(auteur,ligne.encode("utf8")))
            elif is_bonjour(message) and not canal in self.quiet_channels:
                if is_night():
                    answer=random.choice(config.night_answers)
                elif is_day():
                    answer=random.choice(config.bonjour_answers)
                else:
                    answer=random.choice(config.bonsoir_answers)
                serv.privmsg(canal,answer.format(auteur).encode("utf8"))
            elif is_bonne_nuit(message) and not canal in self.quiet_channels:
                answer=random.choice(config.bonne_nuit_answers)
                serv.privmsg(canal,answer.format(auteur).encode("utf8"))
        else:
            if not canal in self.quiet_channels:
                mypseudo=self.nick
                if re.match((u"^("+u"|".join(config.bonjour_triggers)
                                  +u")( {}| all| tout le monde|(|à) tous)(\.|( |)!|)$"
                             ).format(mypseudo).lower(), message.strip().lower()):
                    answer=random.choice(config.bonjour_answers)
                    serv.privmsg(canal,answer.format(auteur).encode("utf8"))

    def on_action(self, serv, ev):
        if ignore_event(serv, ev):
            return
        action = ev.arguments()[0]
        auteur = irclib.nm_to_n(ev.source())
        channel = ev.target()
        try:
            test=bot_unicode(action)
        except UnicodeBotError:
            if config.utf8_trigger and not canal in self.quiet_channels:
                serv.privmsg(canal, (u"%s: %s"%(auteur,random.choice(config.utf8_fail_answers))).encode("utf8"))
            return
        mypseudo=self.nick
        
#        if is_bad_action_trigger(action,mypseudo) and not channel in self.quiet_channels:
#            l1,l2=config.bad_action_answers,config.bad_action_actions
#            n1,n2=len(l1),len(l2)
#            i=random.randrange(n1+n2)
#            if i>=n1:
#                serv.action(channel,l2[i-n1].format(auteur).encode("utf8"))
#            else:
#                serv.privmsg(channel,l1[i].format(auteur).format(auteur).encode("utf8"))
#        if is_good_action_trigger(action,mypseudo) and not channel in self.quiet_channels:
#            l1,l2=config.good_action_answers,config.good_action_actions
#            n1,n2=len(l1),len(l2)
#            i=random.randrange(n1+n2)
#            if i>=n1:
#                serv.action(channel,l2[i-n1].format(auteur).format(auteur).encode("utf8"))
#            else:
#                serv.privmsg(channel,l1[i].format(auteur).format(auteur).encode("utf8"))
    
    def on_kick(self,serv,ev):
        auteur = irclib.nm_to_n(ev.source())
        channel = ev.target()
        victime = ev.arguments()[0]
        raison = ev.arguments()[1]
        if victime==self.nick:
            log(self.serveur,"%s kické de %s par %s (raison : %s)" %(victime,channel,auteur,raison))
            time.sleep(2)
            serv.join(channel)
            username = irclib.nm_to_u(ev.source()).lower()
            print ev.source()
            print channel, username
            if channel == "#déprime" and "peb" in username or "becue" in username:
                print "Kicking peb"
                serv.execute_delayed(5, serv.kick, (auteur, "Va abuser de tes droits ailleurs !"))
    
    def kicker(self, chan, pseudo, raison=None):
        if raison==None:
            raison = config.kick_default_reason
        self.serv.kick(chan,pseudo,raison)

    def quitter(self,chan,leave_message=None):
        if leave_message==None:
            leave_message=random.choice(config.leave_messages)
        self.serv.part(chan,message=leave_message.encode("utf8"))
    
    def mourir(self):
        quit_message=random.choice(config.quit_messages)
        self.die(msg=quit_message.encode("utf8"))
    
    def _getnick(self):
        return self.serv.get_nickname()
    nick=property(_getnick)
    
    def reload(self, auteur=None):
        reload(config)
        if auteur in [None, "SIGHUP"]:
            towrite = "Config reloaded" + " (SIGHUP received)"*(auteur == "SIGHUP")
            for to in config.report_bugs_to:
                self.serv.privmsg(to, towrite)
            log(self.serveur, towrite)
        else:
            self.serv.privmsg(auteur,"Config reloaded")
    
    def start_as_daemon(self, outfile):
        sys.stderr = Logger(outfile)
        self.start()


class Logger(object):
    """Pour écrire ailleurs que sur stdout"""
    def __init__(self, filename="themis.full.log"):
        self.filename = filename

    def write(self, message):
        f = open(self.filename, "a")
        f.write(message)
        f.close()


if __name__=="__main__":
    import sys
    if len(sys.argv)==1:
        print "Usage : themis.py <serveur> [--debug] [--no-output] [--daemon [--pidfile]] [--outfile]"
        print "        --outfile sans --no-output ni --daemon n'a aucun effet"
        exit(1)
    serveur=sys.argv[1]
    if "--daemon" in sys.argv:
        thisfile = os.path.realpath(__file__)
        thisdirectory = thisfile.rsplit("/", 1)[0]
        os.chdir(thisdirectory)
        daemon = True
    else:
        daemon = False
    if "debug" in sys.argv or "--debug" in sys.argv:
        debug=True
    else:
        debug=False
    if "--no-output" in sys.argv or "--daemon" in sys.argv:
        outfile = "/var/log/bots/themis.full.log"
        for arg in sys.argv:
            arg = arg.split("=")
            if arg[0].strip('-') in ["out", "outfile", "logfile"]:
                outfile = arg[1]
        sys.stdout = Logger(outfile)
    serveurs={"a♡":"acoeur.crans.org","acoeur":"acoeur.crans.org","acoeur.crans.org":"acoeur.crans.org",
              "irc":"irc.crans.org","crans":"irc.crans.org","irc.crans.org":"irc.crans.org"}
    try:
        serveur=serveurs[serveur]
    except KeyError:
        print "Server Unknown : %s"%(serveur)
        exit(404)
    themis=Themis(serveur,debug)
    # Si on reçoit un SIGHUP, on reload la config
    def sighup_handler(signum, frame):
        themis.reload("SIGHUP")
    signal.signal(signal.SIGHUP, sighup_handler)
    if daemon:
        child_pid = os.fork()
        if child_pid == 0:
            os.setsid()
            themis.start_as_daemon(outfile)
        else:
            # on enregistre le pid de themis
            pidfile = "/var/run/bots/themis.pid"
            for arg in sys.argv:
                arg = arg.split("=")
                if arg[0].strip('-') in ["pidfile"]:
                    pidfile = arg[1]
            f = open(pidfile, "w")
            f.write("%s\n" % child_pid)
            f.close()
    else:
        themis.start()

